package ASCII::Debug;

=pod

=head1 NAME

ASCII::Debug - debug routines 

=head1 SYNOPSIS

This module is not meant to be used directly.

=head1 DESCRIPTION

=cut

# -------------------------------------------------------------------

use strict;
use warnings;

use base 'Exporter';
our @EXPORT = qw(
printdebug
printinfo
printdumper
);

use Carp qw( carp confess croak );
use Data::Dumper;
use FindBin;

use lib "$FindBin::RealBin";
use lib "$FindBin::RealBin/../lib";
use lib "$FindBin::RealBin/lib";

sub printdebug {
    my ($level,@msg) = @_;
    my $prefix = "debug";
    my $caller_str;
    if(caller(1)) {
	$caller_str = sprintf("%s[%d]",(caller(1))[3,2]);
    } else {
	$caller_str = caller(0);
    }
    if(defined $main::CONF{debug} && $main::CONF{debug} >= $level) {
	printinfo(sprintf("%s[%d] %s",
			  $prefix,$level,
			  $caller_str),
		  @msg);
    }
}

sub printinfo {
    print join(" ",map { defined $_ ? $_ : "_undef_" } @_),"\n";
}

sub printdumper {
    print Dumper(@_);
}

1;
